    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * PaintList.java
    029     * --------------
    030     * (C) Copyright 2003-2011, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   Ryan Hirrlinger (Patch 2999449);
    034     *
    035     * $Id: PaintList.java,v 1.6 2011/11/03 20:53:47 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 13-Aug-2003 : Version 1 (DG);
    040     * 27-Jun-2005 : Fixed equals() method to handle GradientPaint (DG);
    041     * 03-Nov-2011 : Fix equals() method - patch 2999449 by Ryan Hirrlinger (DG);
    042     *
    043     */
    044
    045    package org.jfree.util;
    046
    047    import java.awt.Paint;
    048    import java.io.IOException;
    049    import java.io.ObjectInputStream;
    050    import java.io.ObjectOutputStream;
    051
    052    import org.jfree.io.SerialUtilities;
    053
    054    /**
    055     * A table of {@link Paint} objects.
    056     */
    057    public class PaintList extends AbstractObjectList {
    058
    059        private static final long serialVersionUID = -708669381577938219L;
    060
    061        /**
    062         * Creates a new list.
    063         */
    064        public PaintList() {
    065            super();
    066        }
    067
    068        /**
    069         * Returns a {@link Paint} object from the list.
    070         *
    071         * @param index the index (zero-based).
    072         *
    073         * @return The object.
    074         */
    075        public Paint getPaint(final int index) {
    076            return (Paint) get(index);
    077        }
    078
    079        /**
    080         * Sets the {@link Paint} for an item in the list.  The list is expanded if necessary.
    081         *
    082         * @param index  the index (zero-based).
    083         * @param paint  the {@link Paint}.
    084         */
    085        public void setPaint(final int index, final Paint paint) {
    086            set(index, paint);
    087        }
    088
    089        /**
    090         * Tests the list for equality with another object (typically also a list).
    091         *
    092         * @param obj  the other object (<code>null</code> permitted).
    093         *
    094         * @return A boolean.
    095         */
    096        public boolean equals(final Object obj) {
    097            if (obj == null) {
    098                return false;
    099            }
    100            if (obj == this) {
    101                return true;
    102            }
    103            if (!(obj instanceof PaintList)) {
    104                return false;
    105            }
    106            PaintList that = (PaintList) obj;
    107            int listSize = size();
    108            for (int i = 0; i < listSize; i++) {
    109               if (!PaintUtilities.equal(getPaint(i), that.getPaint(i))) {
    110                   return false;
    111               }
    112            }
    113            return true;
    114        }
    115
    116        /**
    117         * Returns a hash code value for the object.
    118         *
    119         * @return the hashcode
    120         */
    121        public int hashCode() {
    122            return super.hashCode();
    123        }
    124
    125        /**
    126         * Provides serialization support.
    127         *
    128         * @param stream  the output stream.
    129         *
    130         * @throws IOException  if there is an I/O error.
    131         */
    132        private void writeObject(final ObjectOutputStream stream) throws IOException {
    133
    134            stream.defaultWriteObject();
    135            final int count = size();
    136            stream.writeInt(count);
    137            for (int i = 0; i < count; i++) {
    138                final Paint paint = getPaint(i);
    139                if (paint != null) {
    140                    stream.writeInt(i);
    141                    SerialUtilities.writePaint(paint, stream);
    142                }
    143                else {
    144                    stream.writeInt(-1);
    145                }
    146            }
    147
    148        }
    149
    150        /**
    151         * Provides serialization support.
    152         *
    153         * @param stream  the input stream.
    154         *
    155         * @throws IOException  if there is an I/O error.
    156         * @throws ClassNotFoundException  if there is a classpath problem.
    157         */
    158        private void readObject(final ObjectInputStream stream) throws IOException, ClassNotFoundException {
    159
    160            stream.defaultReadObject();
    161            final int count = stream.readInt();
    162            for (int i = 0; i < count; i++) {
    163                final int index = stream.readInt();
    164                if (index != -1) {
    165                    setPaint(index, SerialUtilities.readPaint(stream));
    166                }
    167            }
    168
    169        }
    170
    171    }
    172